//be name khoda

#include <iostream>
#include <map>
#include <string>
#include <algorithm>
#include <vector>
using namespace std;

typedef long long cord;

struct Event{
	cord x,y1,y2;
	long long v;
};

bool cmp(Event a,Event b)
{
	return a.x<b.x || (a.x==b.x && a.v>b.v);
}

class sweepline{
private :
	struct things{
	cord x,y;
	cord cash,b;
	};
	vector <cord> vy;
	things vals[1120000];
public:
	void make(const int i,const int l,const int r)
	{
		if((l+r)/2==l)
		{
			vals[i].x=vy[l];
			vals[i].y=vy[r];
			vals[i].b=0;
			vals[i].cash=0;
			return;
		}
		int m=(l+r)/2;
		make(i*2,l,m);
		make(i*2+1,m,r);
		vals[i].x=vals[i*2].x;
		vals[i].y=vals[i*2+1].y;
		vals[i].b=0;
		vals[i].cash=0;
	}
	cord getposlen()
	{
		return vals[1].cash;
	}
	void add(const Event e,const int i)
	{
		if(vals[i].x>e.y2 || vals[i].y <e.y1)
			return;
		if(vals[i].x>=e.y1 && vals[i].y<=e.y2)
		{
			vals[i].b+=e.v;
			if(!vals[i].b)
			{
				if(vals[i].x!=vals[i].y)
					vals[i].cash=vals[i*2].cash+vals[i*2+1].cash;
			}
			else
				vals[i].cash=vals[i].y-vals[i].x;
			return;
		}
		add(e,i*2);  
		add(e,i*2+1);
		if(vals[i].b)
			vals[i].cash=vals[i].y-vals[i].x;
		else
			vals[i].cash=vals[i*2].cash+vals[i*2+1].cash;
	}
	void fi(vector <cord> vy2)
	{
		vy.clear();
		for(int i=0;i<1110000;i++)
		{
			vals[i].cash=0;
			vals[i].b=0;
		}
		for(int i=0;i<vy2.size();i++)
			vy.push_back(vy2[i]);

	}
};

cord mohiteyevar(vector <Event> &v,sweepline &ey,vector <cord> vy)
{
	ey.fi(vy);
	cord ans2=0,k=0;
	for(int i=0;i<v.size();i++)
	{
		ey.add(v[i],1);
		cord k2=ey.getposlen();
		ans2+=abs(k2-k);
		k=k2;
	}
	return ans2;
}

void set(vector <pair<pair<cord,cord>,pair<cord,cord> > > vcord,int n,vector <Event> &v,sweepline &ey,vector <cord> &vy)
{
	map <cord,bool> ch;
	vy.clear();
	v.clear();
	for(int i=0;i<n;i++)
	{
		pair <cord,cord> p,p2;
		p.first=vcord[i].first.first,p.second=vcord[i].first.second;
		p2.first=vcord[i].second.first,p2.second=vcord[i].second.second;
		Event e,e2;
		e.x=p.first,e.y1=p.second,e.y2=p2.second,e.v=+1;
		e2.x=p2.first,e2.y1=p.second,e2.y2=p2.second,e2.v=-1;
		v.push_back(e);
		v.push_back(e2);
		if(!ch[p.second])
		{
			vy.push_back(p.second);
			ch[p.second]=1;
		}
		if(!ch[p2.second])
		{
			vy.push_back(p2.second);
			ch[p2.second]=1;
		}
	}
	sort(v.begin(),v.end(),cmp);
	sort(vy.begin(),vy.end());
	ey.fi(vy);
	ey.make(1,0,vy.size()-1);
}

int main()
{
	int n;
	cin>>n;
	vector <pair<pair<cord,cord>,pair<cord,cord> > > vcord;
	vector <Event> v;
	vector <cord> vy;
	sweepline ey;
	for(int i=0;i<n;i++)
	{
		pair <cord,cord> p,p2;
		cin>>p.first>>p.second>>p2.first>>p2.second;
		if(p2.first<p.first)
			swap(p.first,p2.first);
		if(p2.second<p.second)
			swap(p.second,p2.second);
		vcord.push_back(make_pair(p,p2));
	}
	set(vcord,n,v,ey,vy);
	
	long long ans=0;
	for(int i=0;i<v.size()-1;i++)
	{
		Event e=v[i];
		ey.add(e,1);
		cord k=ey.getposlen();
		ans+=k*(v[i+1].x-e.x);
	}
	cord ans2=0;
	ans2=mohiteyevar(v,ey,vy);
	for(int i=0;i<n;i++)
		swap(vcord[i].first.first,vcord[i].first.second),swap(vcord[i].second.first,vcord[i].second.second);
	set(vcord,n,v,ey,vy);
	ans2+=mohiteyevar(v,ey,vy);
	cout<<ans<<endl<<ans2<<endl;
	return 0;
}

/*
4
2 0 5 3
3 5 0 2
7 5 4 2
6 3 8 4
*/

/*
2
1 1 2 2
1 2 2 3
*/

/*
7
-1 -10 0 4
-2 -5 5 0
4 -8 6 11
-5 2 8 9
1 6 3 8
10 1 12 6
12 -4 14 2
*/