//be name khoda :)

#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for(int i = 0; i < (int)n; i++)
typedef pair <int, int> pii;

const int N = 4003;

int cross(pii p, pii q) { 
    return p.first * q.second - p.second * q.first; 
}

int area2(pii a, pii b, pii c) { 
    return cross(a, b) + cross(b, c) + cross(c, a); 
}

bool ConvexHull(vector <pii> &pts) {
    vector <pii> up, dn;
    for (int i = 0; i < pts.size(); i++) {
        while (up.size() > 1 && area2(up[up.size() - 2], up.back(), pts[i]) >= 0) 
            up.pop_back();
        while (dn.size() > 1 && area2(dn[dn.size() - 2], dn.back(), pts[i]) <= 0)
            dn.pop_back();
        up.push_back(pts[i]);
        dn.push_back(pts[i]);
    }
    pts = dn;
    for (int i = (int) up.size() - 2; i >= 1; i--) 
        pts.push_back(up[i]);
    for(int i = 2; i < pts.size(); i++)
        if(area2(pts[i - 2], pts[i - 1], pts[i]) != 0)
            return true;
    return false;
}

int main() {
    srand(time(NULL));
    bool dead[N] = {};
    int n = 4000, ans = 0;
    scanf("%d", &n);
    vector <pii> v(n);
    for (int i = 0; i < n; i++) 
        scanf("%d%d", &v[i].first, &v[i].second);
    sort(v.begin(), v.end());
    vector <pii> h(v);
    map<pii, int> index;
    rep(i, n) 
        index[v[i]] = i;
    while(ConvexHull(h)) {
        ans++;
        for (int i = 0; i < h.size(); i++) {
            // cerr << h[i].first << ' ' << h[i].second << ' ' << index[h[i]] << endl;
            dead[index[h[i]]] = true;
        }

        h.clear();
        rep(i, n)
            if(!dead[i]) 
                h.push_back(v[i]);
    }
    cout << ans << endl;
    cerr << "\nTime elapsed: " << 1000 * clock() / CLOCKS_PER_SEC << "ms\n";
    return 0;
}