//be name khoda :)

#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for(int i = 0; i < (int)n; i++)
#define pb push_back
#define sz(x) ((int)x.size())
#define all(x) x.begin(), x.end()

struct PT {
    double x, y;
    PT() {}
    PT(double x, double y) : x(x), y(y) {}
    PT(const PT &p) : x(p.x), y(p.y) {}
    PT operator+(const PT &p) const { return PT(x + p.x, y + p.y); }
    PT operator-(const PT &p) const { return PT(x - p.x, y - p.y); }
    PT operator*(double c) const { return PT(x * c, y * c); }
    PT operator/(double c) const { return PT(x / c, y / c); }
};

double dot(PT p, PT q) { return p.x * q.x + p.y * q.y; }
double dist2(PT p, PT q) { return dot(p - q, p - q); }

ostream &operator<<(ostream &os, const PT &p) {
    return os << "(" << p.x << "," << p.y << ")";
}

double EPS = 1e-12;
double INF = 1e100;
double PIE = acos(-1);

// compute intersection of line through points a and b with
// circle centered at c with radius r > 0
// 	
vector <PT> CircleLineIntersection(PT a, PT b, PT c, double r) {
    vector <PT> ret;
    b = b - a;
    a = a - c;
    double A = dot(b, b);
    double B = dot(a, b);
    double C = dot(a, a) - r * r;
    double D = B * B - A * C;
    if (D < -EPS) return ret;
    ret.push_back(c + a + b * (-B + sqrt(D + EPS)) / A);
    // if (D > EPS)
        ret.push_back(c + a + b * (-B - sqrt(D)) / A);
    return ret;
}

const int N = 2010;

PT a[N];
double len[N];
vector <int> v[N];

double f(double ang) {
	ang = ang / 2 / PIE * 360;
	if(ang < 0)
		ang = -ang;
	else
		ang = 360 - ang;
	return ang;
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);
	int n, r;
	while(cin >> n >> r) {
		if(!n)
			break;
		rep(i, n) {
			cin >> a[i].x >> a[i].y;
			len[i] = sqrt(dot(a[i], a[i]));
			rep(j, i)
				if(dist2(a[i], a[j]) <= 4 * r * r) {
					v[j].pb(i);
					v[i].pb(j);
				}
		}
		int ans = 1;
		rep(i, n) {
			vector <pair <double, int> > seg;
			// cerr << i << ": " << endl;
			for(auto ind : v[i]) {
				PT u = a[ind];
				PT m = PT(-(a[i].y - u.y), (a[i].x - u.x));
				PT v = (u + a[i]) / 2;
				vector <PT> ints = CircleLineIntersection(v, v + m, a[i], r);
				double angle = f(atan2(ints[0].x - a[i].x, ints[0].y - a[i].y));
				double angle2 = f(atan2(ints[1].x - a[i].x, ints[1].y - a[i].y));
				ind++;
				// cerr << a[i] << ' ' << u << endl;
				// cerr << ints[0] << endl;
				// cerr << ints[1] << endl;
				// cerr << angle << ' ' << angle2 << endl;
				// cerr << endl;

				if(angle2 < angle) {
					seg.pb({angle, -ind});
					seg.pb({360, ind});

					seg.pb({0, -ind});
					seg.pb({angle2, ind});
				} else {
					seg.pb({angle, -ind});
					seg.pb({angle2, ind});
				}
			}
			sort(all(seg));
			int now = 1;
			for(auto u : seg) {
				now += (u.second > 0 ? -1 : 1);
				ans = max(ans, now);
				// cerr << pi << ' ' << i << ' ' << now << endl;
			}
			// cout << ans << endl;
		}
		printf("It is possible to cover %d points.\n", ans);
		rep(i, n)
			v[i].clear();
	}
	cerr << "\nTime elapsed: " << 1000 * clock() / CLOCKS_PER_SEC << "ms\n";
	return 0;
}